# Interface SourceSetOutput

All Superinterfaces:
  `AntBuilderAware, Buildable, FileCollection, Iterable<File>`

public interface SourceSetOutput extends FileCollection
A collection of all output directories (compiled classes, processed resources, etc.) - notice that `SourceSetOutput` extends `FileCollection`.

Provides output information of the source set. Allows configuring the default output dirs and specify additional output dirs.

    plugins {
        id 'java'
    }

    sourceSets {
      main {
        //if you truly want to override the defaults:
        output.resourcesDir = file('out/bin')
        // Compiled Java classes should use this directory
        java.destinationDirectory.set(file('out/bin'))
      }
    }

Working with generated resources.

In general, we recommend generating resources into folders different than the regular resourcesDir and classesDirs. Usually, it makes the build easier to understand and maintain. Also it gives some additional benefits because other Gradle plugins can take advantage of the output dirs 'registered' in the SourceSet.output. For example: Java plugin will use those dirs in calculating class paths and for jarring the content; IDEA and Eclipse plugins will put those folders on relevant classpath.

An example how to work with generated resources:

    plugins {
      id 'java'
    }

    def generateResourcesTask = tasks.register("generate-resources", GenerateResourcesTask) {
      resourcesDir.set(layout.buildDirectory.dir("generated-resources/main"))
    }

    // Include all outputs of the `generate-resources` task as outputs of the main sourceSet.
    sourceSets {
      main {
        output.dir(generateResourcesTask)
      }
    }

    abstract class GenerateResourcesTask extends DefaultTask {
      @OutputDirectory
      abstract DirectoryProperty getResourcesDir()

      @TaskAction
      def generateResources() {
        def generated = resourcesDir.file("myGeneratedResource.properties").get().asFile
        generated.text = "message=Stay happy!"
      }
    }

Find more information in `dir(Object)` and `getDirs()`

Since:
  1.0

- ## Nested Class Summary

  ### Nested classes/interfaces inherited from interface FileCollection

  `FileCollection.AntType`

- ## Method Summary

  Modifier and Type
  Method
  Description
  `void`
  `dir(Object dir)`
  Registers an extra output dir.
  `void`
  `dir(Map<String,Object> options, Object dir)`
  Registers an extra output dir and the builtBy information.
  `FileCollection`
  `getClassesDirs()`
  Returns the directories containing compiled classes.
  `FileCollection`
  `getDirs()`
  Returns all dirs registered with #dir method.
  `FileCollection`
  `getGeneratedSourcesDirs()`
  Returns the directories containing generated source files (e.g.
  `@Nullable File`
  `getResourcesDir()`
  Returns the output directory for resources
  `void`
  `setResourcesDir(File resourcesDir)`
  Sets the output directory for resources
  `void`
  `setResourcesDir(Object resourcesDir)`
  Sets the output directory for resources

  ### Methods inherited from interface Buildable

  `getBuildDependencies`

  ### Methods inherited from interface FileCollection

  `addToAntBuilder, addToAntBuilder, contains, filter, filter, getAsFileTree, getAsPath, getElements, getFiles, getSingleFile, isEmpty, minus, plus`

  ### Methods inherited from interface Iterable

  `forEach, iterator, spliterator`

- ## Method Details

  - ### getClassesDirs

    FileCollection getClassesDirs()
    Returns the directories containing compiled classes.
    Returns:
      The classes directories. This value may safely be cast to a `ConfigurableFileCollection`.
    Since:
      4.0

  - ### getResourcesDir

    @Nullable File getResourcesDir()
    Returns the output directory for resources

    See example at `SourceSetOutput`

    Returns:
      The dir resources are copied to.
    Since:
      1.0

  - ### setResourcesDir

    void setResourcesDir(File resourcesDir)
    Sets the output directory for resources

    See example at `SourceSetOutput`

    Parameters:
      `resourcesDir` - the resources dir. Should not be null.
    Since:
      4.0

  - ### setResourcesDir

    void setResourcesDir(Object resourcesDir)
    Sets the output directory for resources

    See example at `SourceSetOutput`

    Parameters:
      `resourcesDir` - the resources dir. Should not be null.
    Since:
      1.0

  - ### dir

    void dir(Map<String,Object> options, Object dir)
    Registers an extra output dir and the builtBy information. Useful for generated resources.

    See example at `SourceSetOutput`

    Parameters:
      `options` - - use 'builtBy' key to configure the 'builtBy' task of the dir
      `dir` - - will be resolved as `Project.file(Object)`
    Since:
      1.0

  - ### dir

    void dir(Object dir)
    Registers an extra output dir. Useful for generated resources.

    See example at `SourceSetOutput`

    Parameters:
      `dir` - - will be resolved as `Project.file(Object)`
    Since:
      1.0

  - ### getDirs

    FileCollection getDirs()
    Returns all dirs registered with #dir method. Each file is resolved as `Project.file(Object)`

    See example at `SourceSetOutput`

    Returns:
      a new instance of registered dirs with resolved files
    Since:
      1.0

  - ### getGeneratedSourcesDirs

    FileCollection getGeneratedSourcesDirs()
    Returns the directories containing generated source files (e.g. by annotation processors during compilation).
    Returns:
      The generated sources directories. Never returns null.
    Since:
      5.2